Index: etc/defaults/security.conf
===================================================================
RCS file: /cvsroot/src/etc/defaults/security.conf,v
retrieving revision 1.14.2.3
diff -u -p -r1.14.2.3 security.conf
--- etc/defaults/security.conf	17 Sep 2007 20:05:06 -0000	1.14.2.3
+++ etc/defaults/security.conf	3 May 2010 15:14:23 -0000
@@ -43,3 +43,4 @@ check_passwd_permit_star=NO
 check_passwd_permit_nonalpha=NO
 max_loginlen=8
 max_grouplen=8
+duplicate_accounts="toor"
Index: etc/security
===================================================================
RCS file: /cvsroot/src/etc/security,v
retrieving revision 1.94.2.6
diff -u -p -r1.94.2.6 security
--- etc/security	17 Sep 2007 20:05:07 -0000	1.94.2.6
+++ etc/security	3 May 2010 15:14:23 -0000
@@ -265,17 +265,26 @@ if checkyesno check_passwd; then
 		column $OUTPUT
 	fi
 
-# To not exclude 'toor', a standard duplicate root account, from the duplicate
-# account test, uncomment the line below (without egrep in it)and comment
-# out the line (with egrep in it) below it.
-#
-#	< $MPBYUID uniq -d -f 1 | awk '{ print $2 }' > $TMP2
-	< $MPBYUID egrep -v '^toor ' | uniq -d -f 1 | awk '{ print $2 }' > $TMP2
+	awk -v "dupaccounts=$duplicate_accounts" \
+	'BEGIN {
+		split(dupaccounts, a, ",");
+		for (i in a) ignore[a[i]]++;
+	}
+	{
+		if ($1 in ignore) next;
+		if ($2 in accounts)
+			dups[$2] = (($2 in dups) ? dups[$2] ", " : "") $1;
+		else
+			accounts[$2] = $1;
+	}
+	END {
+		for (uid in dups)
+			printf "uid %d: %s, %s\n", \
+				uid, accounts[uid], dups[uid];
+	}' < $MPBYUID > $TMP2
 	if [ -s $TMP2 ] ; then
-		printf "\n$MP has duplicate user id's.\n"
-		while read uid; do
-			grep -w $uid $MPBYUID
-		done < $TMP2 | column
+		printf "\n$MP has duplicate user ids.\n"
+		cat $TMP2
 	fi
 fi
 
@@ -492,8 +501,13 @@ if checkyesno check_homes; then
 			printf -- "$uid $file\n"
 		fi
 	done < $MPBYPATH |
-	awk -v "usergroups=$permit_usergroups" '
-	     $1 != $4 && $4 != "root" \
+	awk -v "usergroups=$permit_usergroups" \
+	    -v "dupaccounts=$duplicate_accounts" '
+	     BEGIN {
+		split(dupaccounts, a, ",");
+		for (i in a) ignore[a[i]]++;
+	     }
+	     $1 != $4 && $4 != "root" && !($1 in ignore) \
 		{ print "user " $1 " home directory is owned by " $4 }
 	     $2 ~ /^d....w/ && (!usergroups || $5 != $1) \
 		{ print "user " $1 " home directory is group writable" }
@@ -515,8 +529,13 @@ if checkyesno check_homes; then
 			fi
 		done
 	done < $MPBYPATH |
-	awk  -v "usergroups=$permit_usergroups" '
-	     $1 != $5 && $5 != "root" \
+	awk  -v "usergroups=$permit_usergroups" \
+	     -v "dupaccounts=$duplicate_accounts" '
+	     BEGIN {
+		split(dupaccounts, a, ",");
+		for (i in a) ignore[a[i]]++;
+	     }
+	     $1 != $5 && $5 != "root" && !($1 in ignore) \
 		{ print "user " $1 " " $2 " file is owned by " $5 }
 	     $3 ~ /^-...r/ && (!usergroups || $6 != $1) \
 		{ print "user " $1 " " $2 " file is group readable" }
@@ -544,8 +563,13 @@ if checkyesno check_homes; then
 			fi
 		done
 	done < $MPBYPATH |
-	awk -v "usergroups=$permit_usergroups" '
-	     $1 != $5 && $5 != "root" \
+	awk -v "usergroups=$permit_usergroups" \
+	    -v "dupaccounts=$duplicate_accounts" '
+	     BEGIN {
+		split(dupaccounts, a, ",");
+		for (i in a) ignore[a[i]]++;
+	     }
+	     $1 != $5 && $5 != "root" && !($1 in ignore) \
 		{ print "user " $1 " " $2 " file is owned by " $5 }
 	     $3 ~ /^-....w/ && (!usergroups || $6 != $1) \
 		{ print "user " $1 " " $2 " file is group writable" }
Index: share/man/man5/security.conf.5
===================================================================
RCS file: /cvsroot/src/share/man/man5/security.conf.5,v
retrieving revision 1.29.2.2
diff -u -p -r1.29.2.2 security.conf.5
--- share/man/man5/security.conf.5	12 Jul 2006 14:24:12 -0000	1.29.2.2
+++ share/man/man5/security.conf.5	3 May 2010 15:14:23 -0000
@@ -226,6 +226,15 @@ is enabled, this determines the maximum 
 If
 .Sy check_passwd
 is enabled, this determines the maximum permitted length of login names.
+.It Sy duplicate_accounts
+A comma separated list of user accounts to ignore in the duplicate user
+ID check during the
+.Sy check_passwd
+phase and in the file ownership and permission checks during the
+.Sy check_homes
+phase.
+Defaults to
+.Dq toor .
 .It Sy backup_dir
 Change the backup directory from
 .Pa /var/backup .
